diff --git a/src/cmd-cave.c b/src/cmd-cave.c
index 63edae2366..bb670ed58c 100644
--- a/src/cmd-cave.c
+++ b/src/cmd-cave.c
@@ -397,7 +397,7 @@ void do_cmd_open(struct command *cmd)
 	if (mon) {
 		/* Mimics surprise the player */
 		if (monster_is_mimicking(mon)) {
-			become_aware(cave, mon, player);
+			become_aware(cave, mon);
 
 			/* Mimic wakes up and becomes aware*/
 			monster_wake(mon, false, 100);
@@ -1126,7 +1126,7 @@ void move_player(int dir, bool disarm)
 		/* Attack hostile or neutral monsters */
 		if (!mflag_has(mon->mflag, MFLAG_FRIENDLY)) {
 			if (monster_is_mimicking(mon)) {
-				become_aware(cave, mon, player);
+				become_aware(cave, mon);
 
 				/* Mimic wakes up and becomes aware*/
 				monster_wake(mon, false, 100);
diff --git a/src/effect-handler-general.c b/src/effect-handler-general.c
index b641751652..baa293ff2c 100644
--- a/src/effect-handler-general.c
+++ b/src/effect-handler-general.c
@@ -2100,7 +2100,7 @@ static bool detect_monsters(int y_dist, int x_dist, monster_predicate pred)
 				player->upkeep->redraw |= (PR_MONSTER);
 
 			/* Update the monster */
-			update_mon(player, mon, cave, false);
+			update_mon(mon, cave, false);
 
 			/* Detect */
 			monsters = true;
diff --git a/src/game-world.c b/src/game-world.c
index 22bb61737f..1912ad9f92 100644
--- a/src/game-world.c
+++ b/src/game-world.c
@@ -1146,8 +1146,7 @@ static void process_player_cleanup(void)
 				if (mflag_has(mon->mflag, MFLAG_MARK)) {
 					if (!mflag_has(mon->mflag, MFLAG_SHOW)) {
 						mflag_off(mon->mflag, MFLAG_MARK);
-						update_mon(player, mon, cave,
-							false);
+						update_mon(mon, cave, false);
 					}
 				}
 			}
diff --git a/src/gen-cave.c b/src/gen-cave.c
index 0f5b2ff7ca..dd1dfa0fec 100644
--- a/src/gen-cave.c
+++ b/src/gen-cave.c
@@ -4223,7 +4223,7 @@ struct chunk *arena_gen(struct player *p, int min_height, int min_width) {
 		} while (!square_isempty(c, mon->grid));
 		square_set_mon(c, mon->grid, mon->midx);
 		c->mon_cnt++;
-		update_mon(p, mon, c, true);
+		update_mon(mon, c, true);
 
 		/* Ignore its held objects */
 		mon->held_obj = NULL;
diff --git a/src/mon-attack.c b/src/mon-attack.c
index 8f5534d8a8..b7b7ffa33d 100644
--- a/src/mon-attack.c
+++ b/src/mon-attack.c
@@ -469,7 +469,7 @@ bool make_ranged_attack(struct monster *mon)
 
 	/* If we see a hidden monster try to cast a spell, become aware of it */
 	if (monster_is_camouflaged(mon))
-		become_aware(cave, mon, player);
+		become_aware(cave, mon);
 
 	/* Check for spell failure (innate attacks never fail) */
 	failrate = monster_spell_failrate(mon);
diff --git a/src/mon-make.c b/src/mon-make.c
index c91c82cff0..8539775a5d 100644
--- a/src/mon-make.c
+++ b/src/mon-make.c
@@ -1110,7 +1110,7 @@ s16b place_monster(struct chunk *c, struct loc grid, struct monster *mon,
 	/* Assign monster to its monster group */
 	monster_group_assign(c, new_mon, info, loading);
 
-	update_mon(player, new_mon, c, true);
+	update_mon(new_mon, c, true);
 
 	/* Count the number of "reproducers" */
 	if (rf_has(new_mon->race->flags, RF_MULTIPLY)) c->num_repro++;
diff --git a/src/mon-move.c b/src/mon-move.c
index 5ca15daf72..d56cadbc40 100644
--- a/src/mon-move.c
+++ b/src/mon-move.c
@@ -1153,7 +1153,7 @@ bool multiply_monster(struct chunk *c, const struct monster *mon)
 
 			if (child && monster_is_mimicking(child)
 					&& !monster_is_mimicking(mon)) {
-				become_aware(c, child, player);
+				become_aware(cave, child);
 			}
 		}
 	} else {
@@ -1529,7 +1529,7 @@ static bool monster_turn_try_push(struct chunk *c, struct monster *mon,
 
 		/* Reveal mimics */
 		if (monster_is_mimicking(mon1))
-			become_aware(c, mon1, player);
+			become_aware(cave, mon1);
 
 		if (melee_ok) {
 			return monster_attack_monster(mon, mon1);
@@ -1901,7 +1901,7 @@ static void monster_turn(struct chunk *c, struct monster *mon)
 
 	/* If we see an unaware monster do something, become aware of it */
 	if (did_something && monster_is_camouflaged(mon))
-		become_aware(c, mon, player);
+		become_aware(cave, mon);
 }
 
 
diff --git a/src/mon-util.c b/src/mon-util.c
index 233185cbf0..9d51d1d772 100644
--- a/src/mon-util.c
+++ b/src/mon-util.c
@@ -347,15 +347,14 @@ static void path_analyse(struct chunk *c, struct loc grid)
  * "OPT(player, disturb_near)" (monster which is "easily" viewable moves in some
  * way).  Note that "moves" includes "appears" and "disappears".
  */
-void update_mon(struct player *p, struct monster *mon, struct chunk *c,
-		bool full)
+void update_mon(struct monster *mon, struct chunk *c, bool full)
 {
 	struct monster_lore *lore;
 
 	int d;
 
 	/* If still generating the level, measure distances from the middle */
-	struct loc pgrid = character_dungeon ? p->grid :
+	struct loc pgrid = character_dungeon ? player->grid :
 		loc(c->width / 2, c->height / 2);
 
 	/* Seen at all */
@@ -431,15 +430,14 @@ void update_mon(struct player *p, struct monster *mon, struct chunk *c,
 		}
 
 		/* Normal line of sight and player is not blind */
-		if (square_isview(c, mon->grid) && !p->timed[TMD_BLIND]) {
-
+		if (square_isview(c, mon->grid) && !player->timed[TMD_BLIND]) {
 			/* Painted? If so, easy to see */
 			if (mflag_has(mon->mflag, MFLAG_PAINTED)) {
 				/* Easy to see */
 				easy = flag = true;
 			} else {
 				/* Use "infravision" */
-				if (d <= p->state.see_infra) {
+				if (d <= player->state.see_infra) {
 					/* Learn about warm/cold blood */
 					rf_on(lore->flags, RF_COLD_BLOOD);
 
@@ -458,7 +456,7 @@ void update_mon(struct player *p, struct monster *mon, struct chunk *c,
 					/* Handle invisibility */
 					if (monster_is_invisible(mon)) {
 						/* See invisible */
-						if (player_of_has(p, OF_SEE_INVIS)) {
+						if (player_of_has(player, OF_SEE_INVIS)) {
 							/* Easy to see */
 							easy = flag = true;
 						}
@@ -477,7 +475,7 @@ void update_mon(struct player *p, struct monster *mon, struct chunk *c,
 	/* If a mimic looks like an ignored item, it's not seen */
 	if (monster_is_mimicking(mon)) {
 		struct object *obj = mon->mimicked_obj;
-		if (ignore_item_ok(p, obj))
+		if (ignore_item_ok(player, obj))
 			easy = flag = false;
 	}
 
@@ -502,19 +500,19 @@ void update_mon(struct player *p, struct monster *mon, struct chunk *c,
 			square_light_spot(c, mon->grid);
 
 			/* Update health bar as needed */
-			redraw_health(p, mon);
+			redraw_health(player, mon);
 
 			/* Hack -- Count "fresh" sightings */
 			if (lore->sights < SHRT_MAX)
 				lore->sights++;
 
 			/* Window stuff */
-			p->upkeep->redraw |= PR_MONLIST;
+			player->upkeep->redraw |= PR_MONLIST;
 		}
 	} else if (monster_is_visible(mon)) {
 		/* Not visible but was previously seen - treat mimics differently */
 		if (!mon->mimicked_obj
-				|| ignore_item_ok(p, mon->mimicked_obj)) {
+				|| ignore_item_ok(player, mon->mimicked_obj)) {
 			/* Mark as not visible */
 			mflag_off(mon->mflag, MFLAG_VISIBLE);
 
@@ -522,10 +520,10 @@ void update_mon(struct player *p, struct monster *mon, struct chunk *c,
 			square_light_spot(c, mon->grid);
 
 			/* Update health bar as needed */
-			redraw_health(p, mon);
+			redraw_health(player, mon);
 
 			/* Window stuff */
-			p->upkeep->redraw |= PR_MONLIST;
+			player->upkeep->redraw |= PR_MONLIST;
 		}
 	}
 
@@ -538,11 +536,11 @@ void update_mon(struct player *p, struct monster *mon, struct chunk *c,
 			mflag_on(mon->mflag, MFLAG_VIEW);
 
 			/* Disturb on appearance */
-			if (OPT(p, disturb_near))
-				disturb(p);
+			if (OPT(player, disturb_near))
+				disturb(player);
 
 			/* Re-draw monster window */
-			p->upkeep->redraw |= PR_MONLIST;
+			player->upkeep->redraw |= PR_MONLIST;
 		}
 	} else {
 		/* Change */
@@ -551,11 +549,11 @@ void update_mon(struct player *p, struct monster *mon, struct chunk *c,
 			mflag_off(mon->mflag, MFLAG_VIEW);
 
 			/* Disturb on disappearance */
-			if (OPT(p, disturb_near) && !monster_is_mimicking(mon))
-				disturb(p);
+			if (OPT(player, disturb_near) && !monster_is_mimicking(mon))
+				disturb(player);
 
 			/* Re-draw monster list window */
-			p->upkeep->redraw |= PR_MONLIST;
+			player->upkeep->redraw |= PR_MONLIST;
 		}
 	}
 }
@@ -563,7 +561,7 @@ void update_mon(struct player *p, struct monster *mon, struct chunk *c,
 /**
  * Updates all the (non-dead) monsters via update_mon().
  */
-void update_monsters(struct player *p, bool full)
+void update_monsters(bool full)
 {
 	int i;
 
@@ -576,7 +574,7 @@ void update_monsters(struct player *p, bool full)
 
 		/* Update the monster if alive */
 		if (mon->race)
-			update_mon(p, mon, cave, full);
+			update_mon(mon, cave, full);
 	}
 }
 
@@ -679,14 +677,14 @@ void monster_swap(struct loc grid1, struct loc grid2)
 			if (monster_is_in_view(mon) ||
 				(m2 >= 0 && los(cave, pgrid, grid2)) ||
 				(m2 < 0 && los(cave, grid1, grid2))) {
-				become_aware(cave, mon, player);
+				become_aware(cave, mon);
 			} else {
 				move_mimicked_object(cave, mon, grid1, grid2);
 				player->upkeep->redraw |= (PR_ITEMLIST);
 			}
 		}
 		mon->grid = grid2;
-		update_mon(player, mon, cave, true);
+		update_mon(mon, cave, true);
 
 		/* Affect light? */
 		if (mon->race->light != 0)
@@ -726,14 +724,14 @@ void monster_swap(struct loc grid1, struct loc grid2)
 			if (monster_is_in_view(mon) ||
 				(m1 >= 0 && los(cave, pgrid, grid1)) ||
 				(m1 < 0 && los(cave, grid2, grid1))) {
-				become_aware(cave, mon, player);
+				become_aware(cave, mon);
 			} else {
 				move_mimicked_object(cave, mon, grid2, grid1);
 				player->upkeep->redraw |= (PR_ITEMLIST);
 			}
 		}
 		mon->grid = grid1;
-		update_mon(player, mon, cave, true);
+		update_mon(mon, cave, true);
 
 		/* Affect light? */
 		if (mon->race->light != 0)
@@ -822,11 +820,10 @@ bool monster_can_see(struct chunk *c, struct monster *mon, struct loc grid)
  *
  * \param c Is the chunk with the monster.
  * \param mon Is the monster.
- * \param p Is the player that becomes aware of the mimic.
  * When a player becomes aware of a mimic, we update the monster memory
  * and delete the "fake item" that the monster was mimicking.
  */
-void become_aware(struct chunk *c, struct monster *mon, struct player *p)
+void become_aware(struct chunk *c, struct monster *mon)
 {
 	struct monster_lore *lore = get_lore(mon->race);
 
@@ -841,7 +838,7 @@ void become_aware(struct chunk *c, struct monster *mon, struct player *p)
 		if (mon->mimicked_obj) {
 			struct object *obj = mon->mimicked_obj;
 			char o_name[80];
-			object_desc(o_name, sizeof(o_name), obj, ODESC_BASE, p);
+			object_desc(o_name, sizeof(o_name), obj, ODESC_BASE, player);
 
 			/* Print a message */
 			if (square_isseen(c, obj->grid))
@@ -882,14 +879,14 @@ void become_aware(struct chunk *c, struct monster *mon, struct player *p)
 			square_delete_object(c, obj->grid, obj, false, false);
 
 			/* Since mimicry affects visibility, update that. */
-			update_mon(p, mon, c, false);
+			update_mon(mon, c, false);
 		}
 
 		/* Update monster and item lists */
 		if (mon->race->light != 0) {
-			p->upkeep->update |= (PU_UPDATE_VIEW | PU_MONSTERS);
+			player->upkeep->update |= (PU_UPDATE_VIEW | PU_MONSTERS);
 		}
-		p->upkeep->redraw |= (PR_MONLIST | PR_ITEMLIST);
+		player->upkeep->redraw |= (PR_MONLIST | PR_ITEMLIST);
 	}
 
 	square_note_spot(c, mon->grid);
@@ -1598,7 +1595,7 @@ bool do_mon_take_hit(struct monster *mon, struct player *p, int dam, bool *fear,
 
 	/* Become aware of its presence */
 	if (monster_is_camouflaged(mon))
-		become_aware(cave, mon, p);
+		become_aware(cave, mon);
 
 	/* No damage, we're done */
 	if (dam == 0) return false;
@@ -1650,14 +1647,14 @@ void kill_arena_monster(struct monster *mon)
 {
 	struct monster *old_mon = cave_monster(cave, mon->midx);
 	assert(old_mon);
-	update_mon(player, old_mon, cave, true);
+	update_mon(old_mon, cave, true);
 	old_mon->hp = -1;
 
 	player_kill_monster(old_mon, player, " is defeated!", false);
 	if (!((cave)->depth)) {
 		delete_monster(old_mon->grid);
 	} else {
-		update_mon(player, old_mon, cave, true);
+		update_mon(old_mon, cave, true);
 		old_mon->hp = -1;
 		player_kill_monster(old_mon, player, " is defeated!", false);
 	}
diff --git a/src/mon-util.h b/src/mon-util.h
index c04276eb7a..95c51fe0f5 100644
--- a/src/mon-util.h
+++ b/src/mon-util.h
@@ -27,14 +27,13 @@ void create_mon_flag_mask(bitflag *f, ...);
 struct monster_race *lookup_monster(const char *name);
 struct monster_base *lookup_monster_base(const char *name);
 bool match_monster_bases(const struct monster_base *base, ...);
-void update_mon(struct player *p, struct monster *mon, struct chunk *c,
-	bool full);
-void update_monsters(struct player *p, bool full);
+void update_mon(struct monster *mon, struct chunk *c, bool full);
+void update_monsters(bool full);
 bool monster_carry(struct chunk *c, struct monster *mon, struct object *obj);
 void monster_swap(struct loc grid1, struct loc grid2);
 void monster_wake(struct monster *mon, bool notify, int aware_chance);
 bool monster_can_see(struct chunk *c, struct monster *mon, struct loc grid);
-void become_aware(struct chunk *c, struct monster *m, struct player *p);
+void become_aware(struct chunk *c, struct monster *m);
 void update_smart_learn(struct monster *mon, struct player *p, int flag,
 						int pflag, int element);
 bool find_any_nearby_injured_kin(struct chunk *c, const struct monster *mon);
diff --git a/src/player-calcs.c b/src/player-calcs.c
index 1274ae7d16..4d7700c1a4 100644
--- a/src/player-calcs.c
+++ b/src/player-calcs.c
@@ -1925,12 +1925,12 @@ void update_stuff(struct player *p)
 	if (p->upkeep->update & (PU_DISTANCE)) {
 		p->upkeep->update &= ~(PU_DISTANCE);
 		p->upkeep->update &= ~(PU_MONSTERS);
-		update_monsters(p, true);
+		update_monsters(true);
 	}
 
 	if (p->upkeep->update & (PU_MONSTERS)) {
 		p->upkeep->update &= ~(PU_MONSTERS);
-		update_monsters(p, false);
+		update_monsters(false);
 	}
 
 	if (p->upkeep->update & (PU_PANEL)) {
diff --git a/src/project-mon.c b/src/project-mon.c
index 3306c3489d..4ba3420e43 100644
--- a/src/project-mon.c
+++ b/src/project-mon.c
@@ -1590,7 +1590,7 @@ void project_m(struct source origin, int r, struct loc grid, int dam, int typ,
 	/* Reveal a camouflaged monster if in view and it stopped an effect. */
 	if ((flg & PROJECT_STOP) && monster_is_camouflaged(mon)
 			&& monster_is_in_view(mon)) {
-		become_aware(cave, mon, player);
+		become_aware(cave, mon);
 		/* Reevaluate whether it's seen. */
 		if (monster_is_visible(mon)) {
 			seen = true;
@@ -1630,7 +1630,7 @@ void project_m(struct source origin, int r, struct loc grid, int dam, int typ,
 	if (mon != NULL) {
 		/* Update the monster */
 		if (!mon_died)
-			update_mon(player, mon, cave, false);
+			update_mon(mon, cave, false);
 
 		/* Redraw the (possibly new) monster grid */
 		square_light_spot(cave, mon->grid);
diff --git a/src/project-obj.c b/src/project-obj.c
index df96e406d3..c8a738a24c 100644
--- a/src/project-obj.c
+++ b/src/project-obj.c
@@ -554,8 +554,7 @@ bool project_o(struct source origin, int r, struct loc grid, int dam, int typ,
 				/* Reveal mimics */
 				if (obvious)
 					become_aware(cave, cave_monster(
-						cave, obj->mimicking_m_idx),
-						player);
+						cave, obj->mimicking_m_idx));
 			} else {
 				/* Describe if needed */
 				if (obvious && obj->known && note_kill && !ignore_item_ok(player, obj)) {
diff --git a/src/ui-target.c b/src/ui-target.c
index 8aff36e634..d3147cf563 100644
--- a/src/ui-target.c
+++ b/src/ui-target.c
@@ -34,6 +34,7 @@
 #include "target.h"
 #include "trap.h"
 #include "ui-display.h"
+#include "ui-game.h"
 #include "ui-input.h"
 #include "ui-keymap.h"
 #include "ui-map.h"
